package tech.graphits.catalogue.config;

import org.neo4j.ogm.session.SessionFactory;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.neo4j.repository.config.EnableNeo4jRepositories;
import org.springframework.data.neo4j.transaction.Neo4jTransactionManager;
import org.springframework.transaction.annotation.EnableTransactionManagement;

// tag::sdn_java_config[]
@Configuration
@EnableTransactionManagement
@EnableNeo4jRepositories("tech.graphits.catalogue.repository")
public class Neo4jConfiguration {

  @Bean
  public SessionFactory getSessionFactory() {
    return new SessionFactory(configuration(), "tech.graphits.catalogue.model");
  }

  private org.neo4j.ogm.config.Configuration configuration() {
    return new org.neo4j.ogm.config.Configuration.Builder() // <1>
        .uri("bolt://localhost")
        .credentials("neo4j", "password").build();
  }

  @Bean
  public Neo4jTransactionManager transactionManager() throws Exception {
    return new Neo4jTransactionManager(getSessionFactory());
  }
}
// end::sdn_java_config[]
