package tech.graphits.catalogue.model;

import org.neo4j.ogm.annotation.GeneratedValue;
import org.neo4j.ogm.annotation.Id;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Relationship;

import java.util.Set;

@NodeEntity
public class Livre {

    @Id @GeneratedValue
    private Long id;
    private String titreMaitre;
    private String sousTitre;
    private String titre;

    @Relationship(type = "EST_PUBLIE", direction = Relationship.OUTGOING)
    private Set<Produit> produits;

    // tag::relation_porteuse_donnees[]
    @Relationship(type = "A_POUR_THEME", direction = Relationship.OUTGOING)
    private Set<APourTheme> aPourTheme;
    // end::relation_porteuse_donnees[]

    public Livre() {
    }

    public Livre(String titre, String titreMaitre, String sousTitre) {
        this.titre = titre;
        this.titreMaitre = titreMaitre;
        this.sousTitre = sousTitre;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getTitreMaitre() {
        return titreMaitre;
    }

    public void setTitreMaitre(String titreMaitre) {
        this.titreMaitre = titreMaitre;
    }

    public String getSousTitre() {
        return sousTitre;
    }

    public void setSousTitre(String sousTitre) {
        this.sousTitre = sousTitre;
    }

    public String getTitre() {
        return titre;
    }

    public void setTitre(String titre) {
        this.titre = titre;
    }

    public Set<Produit> getProduit() {
        return produits;
    }

    public void setProduit(Set<Produit> produit) {
        this.produits = produit;
    }

    public Set<APourTheme> getaPourTheme() {
        return aPourTheme;
    }

    public void setaPourTheme(Set<APourTheme> aPourTheme) {
        this.aPourTheme = aPourTheme;
    }
}
