// tag::entite_personne[]
package tech.graphits.catalogue.model;
// end::entite_personne[]

import org.neo4j.ogm.annotation.*;

import java.util.HashSet;
import java.util.Set;

// tag::entite_personne[]
@NodeEntity
public class Personne {

    @Id @GeneratedValue
    private Long id; // <1>

    @Property(name = "email") // <2>
    private String email;

    @Property(name = "nom")
    private String nom;

    @Relationship(type = "EST_AUTEUR") // <3>
    private Set<Livre> livres = new HashSet<>();

    // getters & setters

    // end::entite_personne[]

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getNom() {
        return nom;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }

    public Set<Livre> getLivres() {
        return livres;
    }

    public void setLivres(Set<Livre> livres) {
        this.livres = livres;
    }
// tag::entite_personne[]
}
// end::entite_personne[]
