package tech.graphits.catalogue.repository;

import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;
import org.springframework.data.repository.query.Param;
import tech.graphits.catalogue.model.Personne;

import java.util.List;

// tag::PersonneRepository[]
public interface PersonneRepository extends Neo4jRepository<Personne, Long> {

  Personne findByEmail(String email); // <1>

  Personne findByNomLike(String nom); // <2>

  List<Personne> findAllByLivresTitreMaitre(String titre); // <3>

  @Query("MATCH (l:Livre)<-[:EST_AUTEUR]-(p:Personne) WHERE p.nom = {nom} return count(l)")
  int nombreDeLivresParAuteur(@Param("nom") String nom); // <4>
}
// tag::PersonneRepository[]
