package tech.graphits.catalogue;

import static org.junit.Assert.*;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;
import tech.graphits.catalogue.config.Neo4jConfiguration;
import tech.graphits.catalogue.model.Personne;
import tech.graphits.catalogue.repository.PersonneRepository;
import tech.graphits.catalogue.repository.SimplePersonneRepository;

@RunWith(SpringRunner.class)
@ContextConfiguration(classes = Neo4jConfiguration.class)
public class SDNTest {

	// tag::findAll[]
	@Autowired SimplePersonneRepository repository; // <1>

	@Test
	public void recherche_tous_les_auteurs() {

		Iterable<Personne> all = repository.findAll(); // <2>

		List<Personne> auteurs = new ArrayList<>();
		all.forEach(auteurs::add);
		assertEquals(3, auteurs.size());
	}
	// end::findAll[]

	@Autowired
	PersonneRepository personneRepository;

	@Test
	public void autres() {
		List<Personne> auteurs = personneRepository.findAllByLivresTitreMaitre("Neo4j - Des données et des graphes");
		assertEquals(3, auteurs.size());

		Personne sylvain = personneRepository.findByNomLike("Sylvain*");
		assertNotNull(sylvain);

		int nbLivres = personneRepository.nombreDeLivresParAuteur("Nicolas Mervaillie");
		assertEquals(1, nbLivres);
	}
}
